/*
*
*	stats_handler.h
* --------------------------------------------------------
*
*  This file contains the code for simulating Hudson (1990) style coalescent trees
*  However, here the nodes are never stored in an array, they are kept track of through an array of pointers, and linked into a binary tree using pointers.
*  Gil reassures me that this we be easier when we are regularly realloc() 'ing the tree
*
*
*/

#ifndef _tree_builder_h
#define _tree_builder_h

#include <stdio.h>
#include <stdlib.h>

/*
**********************************************************
* 				PROTOTYPES
**********************************************************
*/

int count_descendants(struct node *node);
void read_infinite_sites(int sample_size, struct node *node, struct mutation_site **start_mutations_list,struct mutation_site **end_infinite_sites_list);
void mark_the_carriers(struct node *node, int *carriers);
void free_infinite_sites(struct mutation_site **start_mutations_list);
void report_infinite_sites(int sample_size, struct mutation_site *start_infinite_sites_list);
void print_tree(struct node *node);
int count_mutations(struct node *node, int sum);

void mark_infinite_alleles(struct node *root, int *highest_allele);
void count_infinite_alleles(struct node **tree, struct node *root, int genomes, int sample_size);

void allele_compactor(int *array, int *temp);
void quicksort_int(int array[], int left, int right);
void make_stat_space(struct statset **stats_array, int number_repeats);
void do_stats(int *population, int *temp, struct statset *stats_array, int repeats, int current_repeat);
void display_stats(struct statset *stats_array, int repeats);

int count_number_phenotypes(int *population);
int count_allele_appearance(int *population);
double count_shared_alleles(int *population);
double count_average_alleles(int *population);
double count_unshared_alleles(int *population);
#endif*/